package Servlet;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

import my.service.CustomerService;

@WebServlet("/login") // servlet url,로그인 요청을 하게 되면 가장 먼저 LoginServlet을 호출하게 된다.
public class LoginServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
    private CustomerService service;
	
    public LoginServlet() { // 생성자에서 service객체 자동 생성
        service = new CustomerService();
    }

	protected void doPost(HttpServletRequest request, HttpServletResponse response) 
			throws ServletException, IOException {

		String path = "/result.jsp";
		
		String id = request.getParameter("id");
		String pwd = request.getParameter("pwd");
		
		HttpSession session = request.getSession();
		session.removeAttribute("loginInfo");
		
		String str = service.login(id, pwd);
		/*--로그인성공시 HttpSession객체의 속성으로 추가 --*/
		JSONParser parser = new JSONParser();
		try {
			Object obj = parser.parse(str);
			JSONObject jsonObj = (JSONObject)obj;
			if((Long)jsonObj.get("status") == 1) {//로그인 성공!
				session.setAttribute("loginInfo", id);
			}
		} catch (ParseException e) {
			e.printStackTrace();
		}
		
		request.setAttribute("result", str);
		RequestDispatcher rd = request.getRequestDispatcher(path);			
		rd.forward(request, response);
		
	}
}