package my.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import my.exception.NotFoundException;
import my.vo.Customer;
import my.dao.CustomerDAO;

public class CustomerDAO {
	// oracle db와의 연동
	Connection con = null;
	PreparedStatement pstmt = null;
	ResultSet rs = null;

	String url = "jdbc:oracle:thin:@localhost:1521:xe";
	String user = "C##ora_user";
	String pw = "hong";

	public CustomerDAO() {
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	public void CloseDB() throws SQLException {
		if (rs != null)
			rs.close();
		if (pstmt != null)
			pstmt.close();
		if (con != null)
			con.close();
	}

	public Customer selectById(String id) throws SQLException, NotFoundException { // login, dupchk할때 SELECT문으로 DB에서 ID를 찾는다.
		Customer customer = new Customer();
		String SelectSQL = "Select * from customers where Customer_id=?";

		con = DriverManager.getConnection(url, user, pw);
		pstmt = con.prepareStatement(SelectSQL);
		pstmt.setString(1, id);
		rs = pstmt.executeQuery();

		String dbid = null;
		String dbpwd = null;
		String dbaddr = null;
		String dbname = null;
		String dbbuildingno = null;
		int customerStatus = 0;

		if (rs.next()) {
			dbid = rs.getString("customer_id");
			dbpwd = rs.getString("customer_pwd");
			customerStatus = rs.getInt("customer_status");
			dbaddr = rs.getString("CUSTOMER_ADDR");
			dbname = rs.getString("CUSTOMER_NAME");
			dbbuildingno = rs.getString("customer_buildingno");

			customer.setId(dbid);
			customer.setPwd(dbpwd);
			customer.setStatus(customerStatus);
			customer.setAddr(dbaddr);
			customer.setName(dbname);
			customer.setBuildingno(dbbuildingno);

		} else {
			throw new NotFoundException("아이디가 존재하지 않습니다 !");
		}
		CloseDB();
		return customer;
	}

	public int joinMember(Customer c) throws NotFoundException { // join 할때 DB에 INSERT문으로 삽입

		int status = -1;
		String query = "INSERT INTO CUSTOMERS(CUSTOMER_ID,CUSTOMER_STATUS,CUSTOMER_PWD,CUSTOMER_NAME,CUSTOMER_BUILDINGNO,CUSTOMER_ADDR) VALUES ( ?, ?, ?, ?, ?, ?)";

		try {
			con = DriverManager.getConnection(url, user, pw);
			pstmt = con.prepareStatement(query);
			pstmt.setString(1, c.getId());
			pstmt.setInt(2, 1);
			pstmt.setString(3, c.getPwd());
			pstmt.setString(4, c.getName());
			pstmt.setString(5, c.getBuildingno());
			pstmt.setString(6, c.getAddr());
			pstmt.executeUpdate();
			status = 1;
		} catch (SQLException e) {
			e.printStackTrace();
			status = -1;
		}
		try {
			CloseDB();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return status;
	}
}
/*
 * public ArrayList<Customer> getMemberList() { ArrayList<Customer> memberList =
 * new ArrayList<Customer>(); Connection conn = null; PreparedStatement pstmt =
 * null; ResultSet rs = null; Customer member = null;
 * 
 * try { StringBuffer query = new StringBuffer(); String SelectSQL =
 * "SELECT * FROM customers"; conn = DriverManager.getConnection(url, user, pw);
 * pstmt = conn.prepareStatement(SelectSQL); rs = pstmt.executeQuery();
 * 
 * while (rs.next()) { member = new Customer();
 * member.setId(rs.getString("CUSTOMER_ID"));
 * member.setName(rs.getString("CUSTOMER_NAME"));
 * member.setAddr(rs.getString("CUSTOMER_ADDR"));
 * member.setStatus(rs.getInt("CUSTOMER_STATUS")); memberList.add(member); }
 * return memberList;
 * 
 * } catch (Exception sqle) { throw new RuntimeException(sqle.getMessage()); }
 * finally { try { if (pstmt != null) { pstmt.close(); pstmt = null; } if (conn
 * != null) { conn.close(); conn = null; } } catch (Exception e) { throw new
 * RuntimeException(e.getMessage()); } } } }
 */